Z_SRC1=Z_SRC
Z_SRC2=Z_TEMP+6
Z_VLY=Z_TEMP+5

e_bump:

	lda #<-25
	sta bump_ly
	lda #1
	sta bump_lyx
	
@scene_loop:

	;jsr wait_frame

	lda #<SCREEN
	sta <Z_DST+0
	lda #>SCREEN
	sta <Z_DST+1
	
	lda #<bump_map_nx
	sta <Z_SRC1+0
	lda #>bump_map_nx
	sta <Z_SRC1+1
	
	lda #<bump_map_ny
	sta <Z_SRC2+0
	lda #>bump_map_ny
	sta <Z_SRC2+1
	
	lda bump_ly
	eor #$ff
	sec
	adc #0
	sta <Z_VLY

	lda #25
	sta bump_sy
	
@loop1:
	
	ldy #0
	
	.repeat 40

	;sec
	lda (Z_SRC2),y
	adc <Z_VLY
	bpl :+
	eor #$ff
	;adc #0
:
	cmp #16
	bcc :+
	lda #15-1
:
	;clc
	adc (Z_SRC1),y

	tax	
	lda bump_sqrt,x
	
	sta (Z_DST),y

	iny
	;cpy #40
	;bne @loop2
	.endrepeat
	
	lda <Z_DST+0
	clc
	adc #40
	sta <Z_DST+0
	bcc :+
	inc <Z_DST+1
:

	lda <Z_SRC1+0
	clc
	adc #40
	sta <Z_SRC1+0
	bcc :+
	inc <Z_SRC1+1
:

	lda <Z_SRC2+0
	clc
	adc #40
	sta <Z_SRC2+0
	bcc :+
	inc <Z_SRC2+1
:

	inc <Z_VLY
	dec bump_sy
	beq :+
	jmp @loop1
:
	
	
	lda bump_ly
	clc
	adc bump_lyx
	sta bump_ly

	lda bump_lyx
	bpl @down

@up:

	lda bump_ly
	bpl @next
	cmp #<-25
	bcs @next
	lda #1
	sta bump_lyx
	
	jsr check_marker
	bne @done
	
@down:

	lda bump_ly
	bmi @next
	cmp #50
	bcc @next
	lda #<-1
	sta bump_lyx
	
	jsr check_marker
	bne @done
	
@next:

	jmp @scene_loop
	
@done:

	rts
	
	
	
bump_map_nx:
bump_map_ny=bump_map_nx+1000

	.incbin "res\bump.bin"
	
bump_sqrt:

   .byte $a8,$d9,$f2,$a5,$e8,$88,$82,$7f,$23,$35,$68,$7a,$73,$47,$4b,$20
   .byte $d9,$d9,$f2,$a5,$e8,$88,$82,$7f,$23,$35,$68,$7a,$73,$47,$4b,$20
   .byte $f2,$f2,$f2,$a5,$e8,$88,$82,$7f,$23,$35,$68,$7a,$73,$47,$4b,$20
   .byte $a5,$a5,$a5,$e8,$88,$88,$82,$7f,$23,$35,$68,$7a,$73,$47,$4b,$20
   .byte $e8,$e8,$e8,$88,$88,$82,$7f,$23,$23,$35,$68,$7a,$73,$47,$4b,$20
   .byte $88,$88,$88,$88,$82,$7f,$7f,$23,$35,$68,$7a,$73,$47,$47,$4b,$20
   .byte $82,$82,$82,$82,$7f,$7f,$23,$35,$68,$68,$7a,$73,$47,$4b,$20,$20
   .byte $7f,$7f,$7f,$7f,$23,$23,$35,$35,$68,$7a,$73,$47,$47,$4b,$20,$20
   .byte $23,$23,$23,$23,$23,$35,$68,$68,$7a,$73,$73,$47,$4b,$20,$20,$20
   .byte $35,$35,$35,$35,$35,$68,$68,$7a,$73,$73,$47,$4b,$20,$20,$20,$20
   .byte $68,$68,$68,$68,$68,$7a,$7a,$73,$73,$47,$4b,$4b,$20,$20,$20,$20
   .byte $7a,$7a,$7a,$7a,$7a,$73,$73,$47,$47,$4b,$4b,$20,$20,$20,$20,$20
   .byte $73,$73,$73,$73,$73,$47,$47,$47,$4b,$20,$20,$20,$20,$20,$20,$20
   .byte $47,$47,$47,$47,$47,$47,$4b,$4b,$20,$20,$20,$20,$20,$20,$20,$20
   .byte $4b,$4b,$4b,$4b,$4b,$4b,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20
   .byte $20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20
	
bump_ly:	.byte 0
bump_lyx:	.byte 0
bump_sy:	.byte 0