WF_TEXT_RANGE=2
WF_TEXT_DELAY=30


e_greets:

	lda #0
	sta wf_done

	jsr greets_stars_init
	jsr greets_text_init
	
	jsr greets_intro
	jsr greets_waveform
	jmp greets_outro
	
	
	
greets_intro:

	ldx #0

:
	txa
	pha
	
	jsr wait_frame
	
	jsr greets_draw_scroll
	jsr greets_stars_update
	
	pla
	tax
	inx
	cpx #80
	bne :-

	ldx #0

:
	txa
	pha
	
	jsr wait_frame

	jsr greets_stars_update
	
	pla
	tax
	inx
	cpx #50
	bne :-
	
	ldx #80

:
	txa
	pha
	
	jsr wait_frame
	
	jsr greets_draw_scroll
	jsr greets_stars_update
	
	pla
	tax
	inx
	cpx #120
	bne :-
	
	rts


	
greets_outro:

	ldx #120

:
	txa
	pha
	
	jsr wait_frame
	jsr greets_draw_scroll
	jsr greets_stars_update
	
	pla
	tax
	inx
	cpx #160
	bne :-
	
	ldx #0
:
	txa
	pha
	
	jsr wait_frame

	jsr greets_stars_update
	
	pla
	tax
	inx
	cpx #50
	bne :-
	
	ldx #160
:
	txa
	pha
	
	jsr wait_frame
	jsr greets_draw_scroll
	jsr greets_stars_update
	
	pla
	tax
	inx
	cpx #241
	bne :-
	
	rts



greets_draw_scroll:

	ldy #0
:
	lda greets_scroll,x
	sta SCREEN+12*40,y
	inx
	iny
	cpy #40
	bne :-

	rts
	

	
greets_waveform:

	lda #<(8<<2)
	sta wf_wave_width+0
	lda #>(8<<2)
	sta wf_wave_width+1
	lda #0
	sta wf_wave_shape
	lda #0		;0..7
	sta wf_wave_amp
	lda #0
	sta wf_wave_amp_dx
	sta wf_wave_frame
	sta wf_wave_amp_max
	sta wf_frame_cnt

@scene_loop:

	jsr petplay_get_wave
	
	lsr a
	lsr a
	lsr a
	lsr a
	
	beq :+
	sta wf_wave_shape
	lda #2
	jmp :++
:
	lda #<-1
:
	sta wf_wave_amp_dx
	
	lda wf_wave_shape
	bne :+
	lda #2
	sta wf_wave_width+1
	lda #0
	sta wf_wave_width+0
	jmp @nowave
:
	jsr petplay_get_pitch

	cpx #0
	bne :+
	cmp #0
	bne :+
	lda #2
	sta wf_wave_width+1
	lda #0
	sta wf_wave_width+0
	jmp @nowave
:

	stx <Z_TEMP

	lsr <Z_TEMP
	ror a
	lsr <Z_TEMP
	ror a
	lsr <Z_TEMP
	ror a
	lsr <Z_TEMP
	ror a
	sta wf_wave_width+0
	lda <Z_TEMP
	sta wf_wave_width+1
	
	lda wf_wave_frame
	inc wf_wave_frame
	;lsr a
	and #15
	tax
	lda wf_wave_width+0
	clc
	adc wf_wave_sine,x
	sta wf_wave_width+0
	bcc :+
	inc wf_wave_width+1
:
	lda wf_wave_width+1
	bne :+
	lda wf_wave_width+0
	cmp #8
	bcs :+
	lda #8
	sta wf_wave_width+0
:
	
@nowave:

	lda wf_frame_cnt
	and #1
	beq :+
	jsr waveform_calculate
:

	lda wf_wave_amp_max
	lsr a
	lsr a
	sta <Z_TEMP
	
	lda wf_wave_amp
	clc
	adc wf_wave_amp_dx
	bpl :+
	lda #0
:
	cmp #7
	bcc :+
	lda #7
:

	cmp <Z_TEMP
	bcc :+
	lda <Z_TEMP
:
	sta wf_wave_amp
	
	
	jsr wait_frame
	
	lda wf_frame_cnt
	and #1
	beq :+
	jsr waveform_render
:

	jsr greets_stars_update
	jsr greets_text_update

	inc wf_frame_cnt
	
	;jsr check_marker
	;beq :+
	;sta wf_done
;:
	lda wf_text_done+0
	beq :+
	lda wf_text_done+0
	beq :+
	sta wf_done
:

	lda wf_done
	bne @fadeout
	
@fadein:

	lda wf_wave_amp_max
	cmp #7*4
	bcs :+
	inc wf_wave_amp_max
:
	jmp @next
	
@fadeout:

	lda wf_wave_amp_max
	beq @done
	dec wf_wave_amp_max
	
@next:

	jmp @scene_loop

@done:

	rts



Z_SX=Z_TEMP+4		;word
Z_BIT0=Z_TEMP+6		;byte
Z_BIT1=Z_TEMP+7		;byte

waveform_calculate:


	;reset buffers
	
	ldx #0
:
	lda #$20
	sta wf_tile_buf_center,x
	sta wf_tile_buf_top,x
	sta wf_tile_buf_bottom,x
	lda #$00
	sta wf_tile_buf_front,x
	lda #$ff
	sta wf_tile_buf_sx,x
	inx
	cpx #40
	bne :-
	

	;find first bit change
	
@find_non_zero:

	lda #$01
	sta <Z_BIT0
	sta wf_bit_start
	lda #$02
	sta <Z_BIT1
	
	ldx #8
	
@find_non_zero_loop:

	lda wf_wave_shape
	and <Z_BIT0
	sta <Z_TEMP
	lda wf_wave_shape
	and <Z_BIT1
	beq :+
	lda <Z_BIT0
:
	cmp <Z_TEMP
	beq :+
	
	lda <Z_BIT0
	sta wf_bit_start
	jmp @find_non_zero_done
:

	lda <Z_BIT0
	cmp #$80
	rol <Z_BIT0
	lda <Z_BIT1
	cmp #$80
	rol <Z_BIT1
	
	dex
	bne @find_non_zero_loop

@find_non_zero_done:

	;render wave transitions in the central line, from the center as well
	
@calc_right:

	lda #<((320/2)<<2)
	sta <Z_SX+0
	lda #>((320/2)<<2)
	sta <Z_SX+1
	lda wf_bit_start
	sta <Z_BIT0
	cmp #$80
	rol a
	sta <Z_BIT1
	
@calc_right_loop:

	lda wf_wave_shape
	and <Z_BIT0
	sta <Z_TEMP
	lda wf_wave_shape
	and <Z_BIT1
	beq :+
	lda <Z_BIT0
:
	cmp <Z_TEMP
	beq @calc_right_next
	
@calc_right_change:

	lda <Z_SX+1
	sta <Z_TEMP
	lda <Z_SX+0
	lsr <Z_TEMP
	ror a
	lsr <Z_TEMP
	ror a
	pha
	and #7
	tay
	pla
	lsr <Z_TEMP
	ror a
	lsr <Z_TEMP
	ror a
	lsr <Z_TEMP
	ror a
	tax
	
	lda wf_tile_vert_line,y
	sta wf_tile_buf_center,x
	tya
	sta wf_tile_buf_sx,x
	lda wf_wave_shape
	and <Z_BIT0
	sta wf_tile_buf_front,x
	
@calc_right_next:

	lda <Z_BIT0
	cmp #$80
	rol <Z_BIT0
	lda <Z_BIT1
	cmp #$80
	rol <Z_BIT1

	lda <Z_SX+0
	clc
	adc wf_wave_width+0
	sta <Z_SX+0
	lda <Z_SX+1
	adc wf_wave_width+1
	sta <Z_SX+1
	
	;lda <Z_SX+1
	cmp #>(320<<2)
	bcc @calc_right_loop
	bne @calc_right_done
	lda <Z_SX+0
	cmp #<(320<<2)
	bcc @calc_right_loop
	
@calc_right_done:

	lda #<((320/2)<<2)
	sta <Z_SX+0
	lda #>((320/2)<<2)
	sta <Z_SX+1
	lda wf_bit_start
	sta <Z_BIT0
	cmp #$80
	rol a
	sta <Z_BIT1
	
@calc_left:

	lda #<((320/2)<<2)
	sta <Z_SX+0
	lda #>((320/2)<<2)
	sta <Z_SX+1
	lda wf_bit_start
	sta <Z_BIT0
	cmp #$80
	rol a
	sta <Z_BIT1
	
@calc_left_loop:

	lda wf_wave_shape
	and <Z_BIT0
	sta <Z_TEMP
	lda wf_wave_shape
	and <Z_BIT1
	beq :+
	lda <Z_BIT0
:
	cmp <Z_TEMP
	beq @calc_left_next
	
@calc_left_change:

	lda <Z_SX+1
	sta <Z_TEMP
	lda <Z_SX+0
	lsr <Z_TEMP
	ror a
	lsr <Z_TEMP
	ror a
	pha
	and #7
	tay
	pla
	lsr <Z_TEMP
	ror a
	lsr <Z_TEMP
	ror a
	lsr <Z_TEMP
	ror a
	tax
	
	lda wf_tile_vert_line,y
	sta wf_tile_buf_center,x
	tya
	sta wf_tile_buf_sx,x
	lda wf_wave_shape
	and <Z_BIT0
	sta wf_tile_buf_front,x
	
@calc_left_next:

	lda <Z_BIT0
	ror a
	ror <Z_BIT0
	lda <Z_BIT1
	ror a
	ror <Z_BIT1

	lda <Z_SX+0
	sec
	sbc wf_wave_width+0
	sta <Z_SX+0
	lda <Z_SX+1
	sbc wf_wave_width+1
	sta <Z_SX+1
	bpl @calc_left_loop
	
@calc_left_done:
	
	
	;render the connected front top/bottom tiles
	
	ldx #0
	
@connect_loop:

	lda wf_tile_buf_center,x
	cmp #$20
	beq :++
	lda wf_tile_buf_front,x
	bne :+
	lda wf_tile_buf_sx,x
	sta <Z_TEMP
	eor #7
	tay
	lda wf_tile_vert_fill_right,y
	sta wf_tile_buf_top,x
	ldy <Z_TEMP
	lda wf_tile_vert_fill_left,y
	sta wf_tile_buf_bottom,x
	jmp :++
:
	lda wf_tile_buf_sx,x
	tay
	pha
	lda wf_tile_vert_fill_left,y
	sta wf_tile_buf_top,x
	pla
	eor #7
	tay
	lda wf_tile_vert_fill_right,y
	sta wf_tile_buf_bottom,x
:
	
	inx
	cpx #40
	bne @connect_loop


	;fill the gaps at the top
	
	ldx #20

@fill_top_left1:

	cpx #40
	bcs @fill_top_left_done
	
	lda wf_tile_buf_front,x
	bne @fill_top_left_next
	lda wf_tile_buf_top,x
	cmp #$20
	beq @fill_top_left_next

	inx
	
@fill_top_left2:

	cpx #40
	bcs @fill_top_left_done
	
	lda wf_tile_buf_top,x
	cmp #$20
	beq :+
	inx
	jmp @fill_top_left1
:
	lda #$a0
	sta wf_tile_buf_top,x
	inx
	jmp @fill_top_left2
			
@fill_top_left_next:

	inx
	jmp @fill_top_left1

@fill_top_left_done:



	ldx #20

@fill_top_right1:

	txa
	bmi @fill_top_right_done
	
	lda wf_tile_buf_front,x
	beq @fill_top_right_next
	lda wf_tile_buf_top,x
	cmp #$20
	beq @fill_top_right_next

	dex
	
@fill_top_right2:

	txa
	bmi @fill_top_right_done
	
	lda wf_tile_buf_top,x
	cmp #$20
	beq :+
	dex
	jmp @fill_top_right1
:
	lda #$a0
	sta wf_tile_buf_top,x
	dex
	jmp @fill_top_right2
			
@fill_top_right_next:

	dex
	jmp @fill_top_right1

@fill_top_right_done:

	
	;fill the gaps at the bottom
	
	ldx #20

@fill_bottom_left1:

	cpx #40
	bcs @fill_bottom_left_done
	
	lda wf_tile_buf_front,x
	beq @fill_bottom_left_next
	lda wf_tile_buf_bottom,x
	cmp #$20
	beq @fill_bottom_left_next

	inx
	
@fill_bottom_left2:

	cpx #40
	bcs @fill_bottom_left_done
	
	lda wf_tile_buf_bottom,x
	cmp #$20
	beq :+
	inx
	jmp @fill_bottom_left1
:
	lda #$a0
	sta wf_tile_buf_bottom,x
	inx
	jmp @fill_bottom_left2
			
@fill_bottom_left_next:

	inx
	jmp @fill_bottom_left1

@fill_bottom_left_done:



	ldx #20

@fill_bottom_right1:

	txa
	bmi @fill_bottom_right_done
	
	lda wf_tile_buf_front,x
	bne @fill_bottom_right_next
	lda wf_tile_buf_bottom,x
	cmp #$20
	beq @fill_bottom_right_next

	dex
	
@fill_bottom_right2:

	txa
	bmi @fill_bottom_right_done
	
	lda wf_tile_buf_bottom,x
	cmp #$20
	beq :+
	dex
	jmp @fill_bottom_right1
:
	lda #$a0
	sta wf_tile_buf_bottom,x
	dex
	jmp @fill_bottom_right2
			
@fill_bottom_right_next:

	dex
	jmp @fill_bottom_right1

@fill_bottom_right_done:


	rts
	
	
	
greets_star_set_dx:

	jsr rand8
	and #3
	sta <Z_TEMP
	txa
	and #3
	sec
	adc <Z_TEMP
	adc #1
	sta wf_star_dx,x
	
	rts
	
	
	
greets_stars_init:

	ldx #0

@loop:

	lda #255
	sta wf_star_x,x
	
	jsr greets_star_set_dx

	inx
	cpx #WF_STARS_ALL
	bne @loop
	
	rts
	
	
	
greets_stars_update:

	ldx #0
	
@loop:

	lda wf_star_yadr_l,x
	sta <Z_DST+0
	lda wf_star_yadr_h,x
	sta <Z_DST+1
	
	lda wf_star_x,x			;erase star
	lsr a
	lsr a
	tay
	cpy #40
	bcs :+
	lda #$20
	sta (Z_DST),y
:
	
	lda wf_star_x,x
	sec
	sbc wf_star_dx,x
	sta wf_star_x,x
	bcs @next
	lda wf_done
	bne @nospawn
	
	jsr greets_star_set_dx
	jmp @next
	
@nospawn:

	lda #0
	sta wf_star_dx,x
	
@next:

	lda wf_star_x,x
	lsr a				;draw star
	lsr a
	tay
	cpy #40
	bcs :+
	lda #$2e
	sta (Z_DST),y
:

	inx
	cpx #WF_STARS_ALL
	bne @loop
	
	rts
	
	
	
waveform_render:

	lda #<(SCREEN+5*40)
	sta <Z_DST+0
	lda #>(SCREEN+5*40)
	sta <Z_DST+1
	
	lda wf_wave_amp
	sta <Z_TEMP+2
	
	lda wf_wave_shape
	bne :+
	sta <Z_TEMP+2
:

	lda <Z_TEMP+2
	asl a
	asl a
	asl a
	asl a
	sta <Z_TEMP+2
	
	ldx #15
	
waveform_render_loop:

	ldy <Z_TEMP+2
	inc <Z_TEMP+2
	lda wf_amp_lines,y
	tay
	lda wf_amp_routines_l,y 
	sta <Z_TEMP+0
	lda wf_amp_routines_h,y
	sta <Z_TEMP+1
	
	ldy #0
	jmp (Z_TEMP)
	
waveform_render_return:

	lda <Z_DST+0
	clc
	adc #40
	sta <Z_DST+0
	bcc :+
	inc <Z_DST+1
:

	dex
	bne waveform_render_loop
	
	rts
	
	
	
wf_render_empty:

	lda #$20
	jmp wf_render_fill1


wf_render_fill:

	lda #$a0
	
wf_render_fill1:

	.repeat 40,I
	sta (Z_DST),y
	iny
	.endrepeat
	
	jmp waveform_render_return	
	
	
wf_render_center:

	.repeat 40,I
	lda wf_tile_buf_center+I
	sta (Z_DST),y
	iny
	.endrepeat
	
	jmp waveform_render_return
	
	
wf_render_top:

	.repeat 40,I
	lda wf_tile_buf_top+I
	sta (Z_DST),y
	iny
	.endrepeat
	
	jmp waveform_render_return
	
	
wf_render_bottom:

	.repeat 40,I
	lda wf_tile_buf_bottom+I
	sta (Z_DST),y
	iny
	.endrepeat
	
	jmp waveform_render_return
	
	

;X=0,1

greets_text_next:	

	cpx #0
	bne :+
	lda #<greets_list_top
	sta <Z_SRC+0
	lda #>greets_list_top
	sta <Z_SRC+1
	jmp :++
:
	lda #<greets_list_bottom
	sta <Z_SRC+0
	lda #>greets_list_bottom
	sta <Z_SRC+1
:

	lda wf_text_ptr,x
	tay
	
@loop1:

	lda (Z_SRC),y
	cmp #1
	bne :+
	lda #1
	sta wf_text_done,x
	rts
:
	cmp #$20+1
	bcs :+
	iny
	jmp @loop1
:

	tya
	sta wf_text_ptr,x
	
	lda #0
	sta wf_text_len,x
	sta wf_text_pos,x
	lda #3
	sta wf_text_xoff,x
	
@loop2:

	lda (Z_SRC),y
	cmp #$20
	bcc :+
	iny
	inc wf_text_len,x
	jmp @loop2
:

	lda wf_text_pos_cnt
	and #15
	asl a
	sta <Z_TEMP
	lda #40
	sec
	sbc wf_text_len,x
	sec
	sbc #3
	sec
	sbc <Z_TEMP
	cmp #3
	bpl :+
	lda #3
:
	bcs :+
	lda #3
:
	sta wf_text_x,x

	lda wf_text_pos_cnt
	clc
	adc #5
	sta wf_text_pos_cnt
	
	rts
	
	
	
greets_text_init:
	
	lda #64
	sta wf_text_delay+0
	lda #128
	sta wf_text_delay+1

	ldx #0
	jsr greets_text_next
	ldx #1
	jmp greets_text_next	;jsr:rts

	
	
greets_text_update:

	ldx #0
	
@loop:

	cpx #0
	bne :+
	lda #<(SCREEN+1*40)
	sta <Z_DST+0
	lda #>(SCREEN+1*40)
	sta <Z_DST+1	
	lda #<greets_list_top
	sta <Z_SRC+0
	lda #>greets_list_top
	sta <Z_SRC+1
	jmp :++
:
	lda #<(SCREEN+23*40)
	sta <Z_DST+0
	lda #>(SCREEN+23*40)
	sta <Z_DST+1	
	lda #<greets_list_bottom
	sta <Z_SRC+0
	lda #>greets_list_bottom
	sta <Z_SRC+1
:

	lda wf_text_done,x
	beq :+
	jmp @next
:

	lda wf_text_delay,x
	beq :+
	dec wf_text_delay,x
	jmp @next
	
:
	
	lda wf_text_state,x
	bne @state1
	
@state0:

	lda wf_text_ptr,x
	clc
	adc wf_text_pos,x
	tay
	lda (Z_SRC),y
	cmp #$40
	bcc :+
	eor #$c0
:

	pha
	
	lda wf_text_x,x
	clc
	adc wf_text_pos,x
	clc	
	adc wf_text_xoff,x
	tay
	
	pla
	sta (Z_DST),y
	iny
	lda #$20
	sta (Z_DST),y

	lda wf_text_xoff,x
	beq :+
	dec wf_text_xoff,x
	jmp @next
:

	lda #WF_TEXT_RANGE
	sta wf_text_xoff,x
	
	lda wf_text_pos,x
	clc
	adc #1
	cmp wf_text_len,x
	bcs :+
	inc wf_text_pos,x
	jmp @next
:

	lda #1
	sta wf_text_state,x
	lda #0
	sta wf_text_pos,x
	sta wf_text_xoff,x
	lda #WF_TEXT_DELAY
	sta wf_text_delay,x

	jmp @next
	
@state1:

	lda wf_text_ptr,x
	clc
	adc wf_text_pos,x
	tay
	lda (Z_SRC),y
	cmp #$40
	bcc :+
	eor #$c0
:

	pha
	
	lda wf_text_x,x
	clc
	adc wf_text_pos,x
	clc		;intentional
	sbc wf_text_xoff,x
	tay
	
	pla
	sta (Z_DST),y
	iny
	lda #$20
	sta (Z_DST),y
	
	lda wf_text_xoff,x
	cmp #WF_TEXT_RANGE
	bcs :+
	inc wf_text_xoff,x
	jmp @next
:

	dey
	lda #$20
	sta (Z_DST),y
	
	lda #0
	sta wf_text_xoff,x
	
	lda wf_text_pos,x
	clc
	adc #1
	cmp wf_text_len,x
	bcs :+
	inc wf_text_pos,x
	jmp @next
:

	lda #0
	sta wf_text_state,x
	lda wf_text_len,x
	sec		;intentional
	adc wf_text_ptr,x
	sta wf_text_ptr,x
	
	jsr greets_text_next

@next:

	inx
	cpx #2
	beq :+
	jmp @loop
:

	rts
	
	

WF_AMP_E=0
WF_AMP_F=1
WF_AMP_C=2
WF_AMP_T=3
WF_AMP_B=4

wf_amp_routines_l:

	.byte <wf_render_empty
	.byte <wf_render_fill
	.byte <wf_render_center
	.byte <wf_render_top
	.byte <wf_render_bottom
	
wf_amp_routines_h:

	.byte >wf_render_empty
	.byte >wf_render_fill
	.byte >wf_render_center
	.byte >wf_render_top
	.byte >wf_render_bottom
	
wf_amp_lines:

	.byte WF_AMP_E,WF_AMP_E,WF_AMP_E,WF_AMP_E,WF_AMP_E,WF_AMP_E,WF_AMP_E,WF_AMP_F,WF_AMP_E,WF_AMP_E,WF_AMP_E,WF_AMP_E,WF_AMP_E,WF_AMP_E,WF_AMP_E,0
	.byte WF_AMP_E,WF_AMP_E,WF_AMP_E,WF_AMP_E,WF_AMP_E,WF_AMP_E,WF_AMP_T,WF_AMP_C,WF_AMP_B,WF_AMP_E,WF_AMP_E,WF_AMP_E,WF_AMP_E,WF_AMP_E,WF_AMP_E,0
	.byte WF_AMP_E,WF_AMP_E,WF_AMP_E,WF_AMP_E,WF_AMP_E,WF_AMP_T,WF_AMP_C,WF_AMP_C,WF_AMP_C,WF_AMP_B,WF_AMP_E,WF_AMP_E,WF_AMP_E,WF_AMP_E,WF_AMP_E,0
	.byte WF_AMP_E,WF_AMP_E,WF_AMP_E,WF_AMP_E,WF_AMP_T,WF_AMP_C,WF_AMP_C,WF_AMP_C,WF_AMP_C,WF_AMP_C,WF_AMP_B,WF_AMP_E,WF_AMP_E,WF_AMP_E,WF_AMP_E,0
	.byte WF_AMP_E,WF_AMP_E,WF_AMP_E,WF_AMP_T,WF_AMP_C,WF_AMP_C,WF_AMP_C,WF_AMP_C,WF_AMP_C,WF_AMP_C,WF_AMP_C,WF_AMP_B,WF_AMP_E,WF_AMP_E,WF_AMP_E,0
	.byte WF_AMP_E,WF_AMP_E,WF_AMP_T,WF_AMP_C,WF_AMP_C,WF_AMP_C,WF_AMP_C,WF_AMP_C,WF_AMP_C,WF_AMP_C,WF_AMP_C,WF_AMP_C,WF_AMP_B,WF_AMP_E,WF_AMP_E,0
	.byte WF_AMP_E,WF_AMP_T,WF_AMP_C,WF_AMP_C,WF_AMP_C,WF_AMP_C,WF_AMP_C,WF_AMP_C,WF_AMP_C,WF_AMP_C,WF_AMP_C,WF_AMP_C,WF_AMP_C,WF_AMP_B,WF_AMP_E,0
	.byte WF_AMP_T,WF_AMP_C,WF_AMP_C,WF_AMP_C,WF_AMP_C,WF_AMP_C,WF_AMP_C,WF_AMP_C,WF_AMP_C,WF_AMP_C,WF_AMP_C,WF_AMP_C,WF_AMP_C,WF_AMP_C,WF_AMP_B,0
	

wf_tile_vert_line:			.byte $65,$54,$47,$42,$5d,$48,$59,$67
wf_tile_vert_fill_left:		.byte $65,$74,$75,$61,$f6,$ea,$e7,$e0
wf_tile_vert_fill_right:	.byte $67,$6a,$76,$e1,$f5,$f4,$e5,$e0


greets_scroll:

	.byte $20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20
	.byte $65,$65,$65,$65,$74,$74,$74,$74,$75,$75,$75,$75,$61,$61,$61,$61,$f6,$f6,$f6,$f6,$ea,$ea,$ea,$ea,$e7,$e7,$e7,$e7,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0
	.byte $e0,$e0,$e0,$e0,$e0,$e0,$87,$e0,$92,$a0,$85,$a0,$85,$a0,$94,$a0,$89,$a0,$8e,$a0,$87,$a0,$93,$e0,$e0,$e0,$94,$e0,$8f,$e0,$ae,$e0,$ae,$e0,$ae,$e0,$e0,$e0,$e0,$e0
	.byte $e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0
	.byte $e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$ae,$e0,$ae,$e0,$ae,$e0,$81,$e0,$8e,$e0,$84,$e0,$e0,$e0,$99,$e0,$8f,$e0,$95,$e0,$a1,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0
	.byte $e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e0,$e5,$e5,$e5,$e5,$f4,$f4,$f4,$f4,$f5,$f5,$f5,$f5,$e1,$e1,$e1,$e1,$76,$76,$76,$76,$6a,$6a,$6a,$6a,$67,$67,$67,$67
	.byte $20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20



greets_list_top:

	.byte "MR287CC",0
	.byte "CHRV",0
	.byte "UTZ",0
	.byte "ATARITUFTY",0
	.byte "SERGIO ELISONDO",0
	.byte "VILER",0
	.byte "REENIGNE",0
	.byte "CTRIX",0
	.byte "ELEAZAR GALINDO",0
	.byte "UTTERCHAOS",0
	.byte "EINAR SAUKAS",0
	.byte "JUSTEVGEN",0
	.byte "ROMAN SOKOLOV",0
	.byte "KINAMAN",0
	.byte "JOE VONDAYL",0
	.byte "NIK-O",0
	.byte 1


greets_list_bottom:

	.byte "ALONE CODER",0
	.byte "SHURAN33",0
	.byte "SAVELIJ",0
	.byte "XXL",0
	.byte "DIMKAM",0
	.byte "THE 8-BIT GUY",0
	.byte "TRIXTER",0
	.byte "PINWIZZ",0
	.byte "KLAXER",0
	.byte "PHOENIX",0
	.byte "TRONIX286",0
	.byte "DENIS GRACHEV",0
	.byte "PETER SOVIETOV",0
	.byte "ROMAN MINDLIN",0
	.byte "DR.BARS",0
	.byte 1



wf_text_state:		.byte 0,0
wf_text_x:			.byte 0,0
wf_text_len:		.byte 0,0
wf_text_pos:		.byte 0,0
wf_text_xoff:		.byte 0,0
wf_text_ptr:		.byte 0,0
wf_text_delay:		.byte 0,0
wf_text_done:		.byte 0,0

wf_text_pos_cnt:	.byte 0



WF_STARS_ALL=8

wf_star_yadr_l:

	.byte <(SCREEN+0*40)
	.byte <(SCREEN+2*40)
	.byte <(SCREEN+3*40)
	.byte <(SCREEN+4*40)
	.byte <(SCREEN+20*40)
	.byte <(SCREEN+21*40)
	.byte <(SCREEN+22*40)
	.byte <(SCREEN+24*40)
	
wf_star_yadr_h:

	.byte >(SCREEN+0*40)
	.byte >(SCREEN+2*40)
	.byte >(SCREEN+3*40)
	.byte >(SCREEN+4*40)
	.byte >(SCREEN+20*40)
	.byte >(SCREEN+21*40)
	.byte >(SCREEN+22*40)
	.byte >(SCREEN+24*40)
	
wf_wave_sine:			.byte 0,0,0,0,1,1,2,2,3,3,3,3,2,2,1,1
	
wf_wave_width:			.word 0
wf_wave_shape:			.byte 0
wf_wave_amp:			.byte 0
wf_wave_amp_dx:			.byte 0
wf_bit_start:			.byte 0
wf_wave_frame:			.byte 0
wf_wave_amp_max:		.byte 0
wf_done:				.byte 0
wf_frame_cnt:			.byte 0

wf_tile_buf_center:		.res 40,0
wf_tile_buf_top:		.res 40,0
wf_tile_buf_bottom:		.res 40,0
wf_tile_buf_sx:			.res 40,0
wf_tile_buf_front:		.res 40,0

wf_star_x:				.res 10,0
wf_star_dx:				.res 10,0