MF_BLUR=$40
MF_INVERT=$20
MF_END=$80



e_morph:

	jsr e_morph_intro

	lda #0
	sta MO_OFF
	
	jsr e_morph_clear_s
	
@loop:

	jsr check_marker
	beq @loop
	
	ldx MO_OFF
	lda e_morph_seq,x
	bmi @done
	
	pha
	and #15
	jsr e_morph_unrle_m
	pla
	pha
	and #MF_BLUR
	beq :+
	jsr e_morph_blur_m
:
	pla
	and #MF_INVERT
	beq :+
	jsr e_morph_invert_m
:
	
	jsr e_morph_anim
	
	inc MO_OFF
	
	jmp @loop
	

@done:

	jmp e_morph_outro		;jsr:rts
	

	
e_morph_anim:

	lda #8
	
@morph:

	pha
	
	jsr e_morph_pre_show
	jsr wait_frame

	jsr e_morph_show
	jsr e_morph_dec
	
	pla
	sec
	sbc #1
	bne @morph
	
	rts
	
	
	
;fills screen buffer with A

e_morph_clear_s:

	ldx #<MO_BUMPS
	stx <Z_DST+0
	ldx #>MO_BUMPS
	stx <Z_DST+1
	ldx #<1000
	ldy #>1000
	
	jmp fill_mem		;jsr:rts
	

	
;fill the screen with the horizontal lines
	
e_morph_intro:


	ldx #0
	
@fill:
	
	stx <Z_LOOP
	
	txa
	and #1
	beq :+
	jsr wait_frame
:
	lda #<(SCREEN+24*40)
	sta <Z_DST+0
	lda #>(SCREEN+24*40)
	sta <Z_DST+1
	
	ldx #0
	
@fill1:

	lda lr_fill_table,x
	cmp #25/2*8+40
	bcs @next
	inc lr_fill_table,x
	cmp #25/2*8
	bcc @next
	sec
	sbc #25/2*8
	sta <Z_TEMP

	txa
	ror a
	bcc @even
	
@odd:

	ldy <Z_TEMP
	lda char_height+0
	sta (Z_DST),y
	jmp @next
	
@even:

	lda #39
	sec
	sbc <Z_TEMP
	tay
	lda char_height+0
	sta (Z_DST),y
	
@next:

	lda <Z_DST+0
	sec
	sbc #40
	sta <Z_DST+0
	bcs :+
	dec <Z_DST+1
:
	inx
	cpx #25
	bne @fill1

	ldx <Z_LOOP
	inx
	cpx #25/2*8+40
	bne @fill
	
	rts
	
	
	
e_morph_outro_src_l:

	.byte 0,0,0,0,0

e_morph_outro_src_h:

	.byte 0,0,0,0,0
	
e_morph_delay:

	.byte 0,0,0,0,0
	
e_morph_outro_char:

	.byte $53,$5a,$2b,$2e,$20
	
e_morph_done:

	.byte 0
	
	
	
e_morph_outro:
	
	ldx #0
	ldy #0
	
@set:

	lda #<e_heart_mask
	sta e_morph_outro_src_l,x
	lda #>e_heart_mask
	sta e_morph_outro_src_h,x
	tya
	sta e_morph_delay,x
	asl a
	tay
	iny
	inx
	cpx #5
	bne @set
	
@frame:

	jsr wait_frame
	
	ldx #0
	
@loop:

	lda e_morph_delay,x
	beq :+
	dec e_morph_delay,x
	sec
	jmp @next
	
:
	lda e_morph_outro_src_l,x
	sta <Z_SRC+0
	lda e_morph_outro_src_h,x
	sta <Z_SRC+1
	
	txa
	pha
	
	lda e_morph_outro_char,x
	
	jsr e_morph_outro_iter
	
	ldy #0
	bcc :+
	iny
:
	sty e_morph_done
	
	pla
	tax
	
	lda <Z_SRC+0
	sta e_morph_outro_src_l,x
	lda <Z_SRC+1
	sta e_morph_outro_src_h,x

@next:

	inx
	cpx #5
	bne @loop
	
	lda e_morph_done
	beq @frame

	rts
	
	
	
e_morph_outro_iter:

	sta <Z_TEMP+4
	
@loop:

	ldy #0
	lda (Z_SRC),y
	
	cmp #$ff
	bne :+
	sec
	rts
:
	inc <Z_SRC+0
	bne :+
	inc <Z_SRC+1
:
	cmp #$fe
	bne :+
	clc
	rts
:

	sta <Z_TEMP+1
	
	lda (Z_SRC),y
	inc <Z_SRC+0
	bne :+
	inc <Z_SRC+1
:

	sta <Z_TEMP+0
	and #$3f
	sta <Z_TEMP+2
	
	.repeat 6
	lsr <Z_TEMP+1
	ror <Z_TEMP+0
	.endrepeat
	
	lda <Z_TEMP+0
	clc
	adc #<SCREEN
	sta <Z_DST+0
	lda <Z_TEMP+1
	adc #>SCREEN
	sta <Z_DST+1
	lda <Z_DST+0
	clc
	adc <Z_TEMP+2
	sta <Z_DST+0
	bcc :+
	inc <Z_DST+1
:

	lda <Z_TEMP+4
	sta (Z_DST),y
	
	lda #39
	sec
	sbc <Z_TEMP+2
	sta <Z_TEMP+2
	
	lda <Z_TEMP+0
	clc
	adc #<SCREEN
	sta <Z_DST+0
	lda <Z_TEMP+1
	adc #>SCREEN
	sta <Z_DST+1
	lda <Z_DST+0
	clc
	adc <Z_TEMP+2
	sta <Z_DST+0
	bcc :+
	inc <Z_DST+1
:

	lda <Z_TEMP+4
	sta (Z_DST),y
	
	jmp @loop
	
	
	
;unpack RLE heightmap
;A=picture number

e_morph_unrle_m:

	asl a
	tax
	lda morph_pic_list+0,x
	sta <Z_SRC+0
	lda morph_pic_list+1,x
	sta <Z_SRC+1
	
	lda #<MO_BUMPM
	sta <Z_DST+0
	lda #>MO_BUMPM
	sta <Z_DST+1
	
@unrle:

	ldy #0
	lda (Z_SRC),y
	beq @done
	lsr a
	lsr a
	lsr a
	tax
	lda (Z_SRC),y
	inc <Z_SRC+0
	bne :+
	inc <Z_SRC+1
:
	and #7
	
@unrle1:

	sta (Z_DST),y
	iny
	dex
	bne @unrle1
	
	tya
	clc
	adc <Z_DST+0
	sta <Z_DST+0
	bcc :+
	inc <Z_DST+1
:
	jmp @unrle
	
@done:

	rts
	


e_morph_pre_show:

	.repeat 8,I
	lda char_height+I
	sta Z_TEMP+I
	.endrepeat
	
	rts
	
	
	
e_morph_show:
	
	;four separate loops to avoid tearing as much as possible
	
	ldx #0
	
@loop1:

	.repeat 50,I
	ldy MO_BUMPS+I,x		;4+
	lda <Z_TEMP,y			;4
	sta SCREEN+I,x			;5
	.endrepeat
	
	txa
	clc
	adc #50
	tax
	cmp #250
	beq :+					;2/3
	jmp @loop1				;3
:

	ldx #0
	
@loop2:

	.repeat 50,I
	ldy MO_BUMPS+250+I,x	;4+
	lda <Z_TEMP,y			;4
	sta SCREEN+250+I,x		;5
	.endrepeat
	
	txa
	clc
	adc #50
	tax
	cmp #250
	beq :+					;2/3
	jmp @loop2				;3
:

	ldx #0
	
@loop3:

	.repeat 50,I
	ldy MO_BUMPS+500+I,x	;4+
	lda <Z_TEMP,y			;4
	sta SCREEN+500+I,x		;5
	.endrepeat
	
	txa
	clc
	adc #50
	tax
	cmp #250
	beq :+					;2/3
	jmp @loop3				;3
:

	ldx #0
	
@loop4:

	.repeat 50,I
	ldy MO_BUMPS+750+I,x	;4+
	lda <Z_TEMP,y			;4
	sta SCREEN+750+I,x		;5
	.endrepeat
	
	txa
	clc
	adc #50
	tax
	cmp #250
	beq :+					;2/3
	jmp @loop4				;3
:

	rts
	
	
	
e_morph_dec:

	ldx #0
	
@loop:

	.repeat 25,I
	lda MO_BUMPS+I*40,x		;4+
	cmp MO_BUMPM+I*40,x		;4+
	beq :++					;2/3
	bcs :+					;2/3
	inc MO_BUMPS+I*40,x		;7
	bcc :++					;3 bcc because it is shorter than jmp
:
	dec MO_BUMPS+I*40,x		;7
:
	.endrepeat

	inx						;2
	cpx #40					;2
	beq :+					;2/3
	jmp @loop				;3
:
	rts
	
	
	
e_morph_blur_m:

	lda #<MO_BUMPM
	sta <Z_SRC+0
	lda #>MO_BUMPM
	sta <Z_SRC+1

	lda #25-2
	sta <Z_CNT
	
@loop1:

	ldx #40-2
	ldy #0
	
@loop2:

	tya
	pha
	
	lda (Z_SRC),y
	iny
	clc
	adc (Z_SRC),y
	iny
	adc (Z_SRC),y
	sta <Z_TEMP
	tya
	clc
	adc #40
	tay
	lda <Z_TEMP
	clc
	adc (Z_SRC),y
	dey
	sty <Z_TEMP+1
	dey
	adc (Z_SRC),y
	sta <Z_TEMP
	tya
	clc
	adc #40
	tay
	lda <Z_TEMP
	clc
	adc (Z_SRC),y
	iny
	adc (Z_SRC),y
	iny
	adc (Z_SRC),y
	
	lsr a
	lsr a
	lsr a
	ldy <Z_TEMP+1
	sta (Z_SRC),y
	
	pla
	tay
	iny
	
	dex
	bne @loop2
	
	lda <Z_SRC+0
	clc
	adc #40
	sta <Z_SRC+0
	bcc :+
	inc <Z_SRC+1
:

	dec <Z_CNT
	bne @loop1

	rts
	
	
	
e_morph_invert_m:

	lda #<MO_BUMPM
	sta <Z_DST+0
	lda #>MO_BUMPM
	sta <Z_DST+1
	
	ldx #25
@loop:
	ldy #0
@loop1:
	lda (Z_DST),y
	eor #$07
	sta (Z_DST),y
	iny
	cpy #40
	bne @loop1
	
	lda <Z_DST+0
	clc
	adc #40
	sta <Z_DST+0
	bcc :+
	inc <Z_DST+1
:
	dex
	bne @loop

	rts
	
	
	
char_height:
	.byte $64,$52,$46,$40,$43,$44,$45,$63
	
lr_fill_table:
	.repeat 25/2+1,I
	.byte 25/2*8-I*8,25/2*8-I*8
	.endrepeat
	
morph_pic_list:
	.word morph_pic_1
	.word morph_pic_2
	.word morph_pic_3
	.word morph_pic_4

morph_pic_1:
	.incbin "res/morph_1.bin"
morph_pic_2:
	.incbin "res/morph_2.bin"
morph_pic_3:
	.incbin "res/morph_3.bin"
morph_pic_4:
	.incbin "res/morph_4.bin"
	
e_morph_seq:
	.byte 0|MF_BLUR,0|MF_BLUR|MF_INVERT,0,0|MF_INVERT
	.byte 1|MF_BLUR,1|MF_BLUR|MF_INVERT,1,1|MF_INVERT
	.byte 2|MF_BLUR,2|MF_BLUR|MF_INVERT,2,2|MF_INVERT
	.byte 3|MF_BLUR,3|MF_BLUR|MF_INVERT,3,3|MF_INVERT
	.byte MF_END
	
e_heart_mask:
	.incbin "res/heartsh.bin"
	
	
	
MO_BUMPS:	.res 1000,0
MO_BUMPM:	.res 1000,0
MO_OFF:		.byte 0
