NOISE_FRAMES_PER_STEP=30

e_noise:
	
	lda #0
	sta VIA_SR
	lda #$10
	sta VIA_CR
	lda #5
	sta VIA_T2CL
	
	lda #128
	sta noise_ptr
	lda #0
	sta noise_step
	sta noise_snd_ptr
	
	sei
	
@scene_loop:

	lda #0
	sta noise_frame
	
@frame_loop:

	ldx noise_ptr
	ldy #12

@fill:

	jsr rand8
	and #15
	adc noise_step
	sta noise_buf,x
	inx
	dey
	bne @fill
	
	stx noise_ptr
	
	;jsr wait_frame
	
	jsr rand8
	sta <Z_TEMP
	
	ldy #0
	
@show:	
	
	.repeat 5,J
	
	lda noise_snd_ptr
	and #15
	tax
	jsr rand8
	eor <Z_TEMP
	eor noise_step
	and noise_sound_mask,x
	sta VIA_SR
	clc

	.repeat 8,I
	ldx <Z_TEMP
	inc <Z_TEMP
	lda noise_buf,x
	adc noise_pic+((J*8+I)*25),y
	tax
	lda noise_tiles,x
	sta SCREEN+((J*8+I)*25),y
	.endrepeat
	
	.endrepeat

	iny
	cpy #25
	beq :+
	jmp @show
:
	

	inc noise_frame
	lda noise_frame
	cmp #NOISE_FRAMES_PER_STEP
	bcs :+
	jmp @frame_loop
:

	lda noise_step
	clc
	adc #16
	sta noise_step
	inc noise_snd_ptr

	jmp @scene_loop
	
	
noise_pic:

	.incbin "res\noise_pic.bin"
	
noise_tiles:

	.byte $20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$6c,$7b,$7c,$7e,$7f,$ff
	.byte $20,$6c,$7b,$7c,$7e,$7f,$ff,$20,$20,$20,$6c,$7b,$7c,$7e,$7f,$ff
	.byte $20,$6c,$7b,$7c,$7e,$7f,$ff,$61,$e1,$62,$e2,$20,$61,$e1,$62,$e2
	.byte $20,$6c,$7b,$7c,$7e,$7f,$ff,$61,$e1,$62,$e2,$ec,$fb,$fc,$fe,$e0
	.byte $20,$61,$e1,$62,$e2,$e0,$e0,$61,$e1,$62,$e2,$ec,$fb,$fc,$fe,$e0
	.byte $ec,$fb,$fc,$fe,$e0,$ec,$fb,$fc,$fe,$e0,$ec,$fb,$fc,$fe,$e0,$e0
	.byte $20,$61,$e1,$62,$e2,$e0,$e0,$61,$e1,$62,$e2,$ec,$fb,$fc,$fe,$e0
	.byte $20,$6c,$7b,$7c,$7e,$7f,$ff,$61,$e1,$62,$e2,$ec,$fb,$fc,$fe,$e0
	.byte $20,$6c,$7b,$7c,$7e,$7f,$ff,$61,$e1,$62,$e2,$20,$61,$e1,$62,$e2
	.byte $20,$6c,$7b,$7c,$7e,$7f,$ff,$20,$20,$20,$6c,$7b,$7c,$7e,$7f,$ff
	.byte $20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$6c,$7b,$7c,$7e,$7f,$ff
	.byte $20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$6c,$7b,$7c,$7e,$7f,$ff
	.byte $20,$6c,$7b,$7c,$7e,$7f,$ff,$20,$20,$20,$6c,$7b,$7c,$7e,$7f,$ff
	.byte $20,$6c,$7b,$7c,$7e,$7f,$ff,$61,$e1,$62,$e2,$20,$61,$e1,$62,$e2
	.byte $20,$6c,$7b,$7c,$7e,$7f,$ff,$61,$e1,$62,$e2,$20,$61,$e1,$62,$e2
	.byte $20,$6c,$7b,$7c,$7e,$7f,$ff,$20,$20,$20,$6c,$7b,$7c,$7e,$7f,$ff

noise_sound_mask:

	.byte %00000001
	.byte %00010001
	.byte %01001001
	.byte %01010101
	.byte %01110101
	.byte %01110111
	.byte %01111101
	.byte %11110101
	.byte %11110101
	.byte %01111101
	.byte %01110111
	.byte %01110101
	.byte %01010101
	.byte %01001001
	.byte %00010001
	.byte %00000001
	

	
noise_buf:			.res 256,0
noise_ptr:			.byte 0
noise_step:			.byte 0
noise_frame:		.byte 0
noise_snd_ptr:		.byte 0