VOICE_STOP_BYTE=$a1

V_FACE_POS=(SCREEN+(5*40)+17)
V_TEXT_POS=(SCREEN+(24*40)+2)

VO_CDNSTXZ=0*6
VO_OUWR=1*6
VO_AEI=2*6
VO_BMP=3*6
VO_IDLE=4*6
VO_LEFT=5*6
VO_RIGHT=6*6
VO_BLINK=7*6
VO_ZOOM_5=8*6
VO_ZOOM_4=9*6
VO_ZOOM_3=10*6
VO_ZOOM_2=11*6
VO_ZOOM_1=12*6
VO_FACES_ALL=13

VF_SOUND=$fa
VF_MUTE=$fb
VF_DELCHAR=$fc
VF_CHAR=$fd
VF_PLAY=$fe
VF_END=$ff


	
e_voice:

	lda #<voice_screen
	sta <Z_SRC+0
	lda #>voice_screen
	sta <Z_SRC+1

	jsr wait_frame

@draw_pic:
	
	ldy #0
	lda (Z_SRC),y
	cmp #$fe
	bcc @draw_char
	cmp #$ff
	beq @draw_done

	inc <Z_SRC+0
	bne :+
	inc <Z_SRC+1
:
	
	jsr wait_frame
	
	jsr rand8
	and #$f0
	sta VIA_SR
	lda #$10
	sta VIA_CR
	jsr rand8
	eor <Z_DST+0
	and #$a0
	sta VIA_T2CL
	
	jmp @draw_pic
	
@draw_char:

	sta <Z_DST+1
	iny
	lda (Z_SRC),y
	iny
	clc
	adc #<SCREEN
	sta <Z_DST+0
	lda <Z_DST+1
	adc #>SCREEN
	sta <Z_DST+1

	lda (Z_SRC),y
	ldy #0
	sta (Z_DST),y
	
	lda <Z_SRC+0
	clc
	adc #3
	sta <Z_SRC+0
	bcc :+
	inc <Z_SRC+1
:
	jmp @draw_pic
	
@draw_done:

	lda #0
	sta VIA_SR	
	lda #$0
	sta VIA_CR
	
	lda #0
	sta VOICE_BIT
	sta VOICE_PTR+0
	sta VOICE_PTR+1
	sta VOICE_FACEANIM
	sta VOICE_PREVFACE
	sta VOICE_TEXT_PTR
	sta VOICE_SCR_PTR
	lda #VO_IDLE
	sta VOICE_FACE
	
	sei
	
@loop:

	ldx VOICE_FACEANIM
	inc VOICE_FACEANIM
	lda voice_face_anim,x
	cmp #VF_SOUND
	bcc @anim
	beq @sound
	cmp #VF_MUTE
	beq @mute
	cmp #VF_DELCHAR
	beq @delchar
	cmp #VF_PLAY
	beq @play
	cmp #VF_END
	bne @char
	jmp @done
	
@sound:

	lda VOICE_FACE
	and #$0f
	sta VIA_SR
	lda #$10
	sta VIA_CR
	lda VOICE_FACE
	lsr a
	lsr a
	adc #16
	sta VIA_T2CL
	
	jmp @loop
	
@mute:

	lda #0
	sta VIA_SR	
	lda #$0
	sta VIA_CR
	
	jmp @loop
	
@delchar:
	
	dec VOICE_SCR_PTR
	ldx VOICE_SCR_PTR
	lda #$20
	sta V_TEXT_POS,x

	jmp @loop
	
@char:

	ldx VOICE_TEXT_PTR
	inc VOICE_TEXT_PTR
	ldy VOICE_SCR_PTR
	inc VOICE_SCR_PTR
	lda voice_text,x
	cmp #$20
	beq @char
	sta V_TEXT_POS,y

	jmp @loop
	
@play:

	lda #<voice_data
	sta VOICE_PTR+0
	lda #>voice_data
	sta VOICE_PTR+1
	lda #$80
	sta VOICE_BIT
	lda #8
	sta VOICE_CNT
	
	jmp @loop
	
@anim:

	sta VOICE_FACE
	ldx VOICE_FACE
	cpx VOICE_PREVFACE
	beq @nodraw
	
	stx VOICE_PREVFACE
	
	ldy #0
		
@drawloop:
	
	.repeat 8,I
	lda voice_face+I*(VO_FACES_ALL*6),x
	sta V_FACE_POS+I*40,y
	.endrepeat
	
	inx
	iny
	cpy #6
	bne @drawloop
	
@nodraw:
	
	ldx #0
	jsr e_voice_play_block
	jsr e_voice_play_block
	ldx #32
	jsr e_voice_play_block
	
	jmp @loop

@done:

	cli
	
	jsr e_fade
	
	rts
	
	
	
;X=samples to play

e_voice_play_block:

	lda VOICE_PTR+0			;4
	sta <Z_SRC+0			;3
	lda VOICE_PTR+1			;4
	sta <Z_SRC+1			;3
	
@loop:

	ldy #0					;2
	lda (Z_SRC),y			;5+
	cmp #VOICE_STOP_BYTE	;2
	beq @mute				;2/3
	
	and VOICE_BIT			;4
	cmp VOICE_BIT			;4
	sbc VOICE_BIT			;4
	
	and #$20				;2
	ora #$cc				;2
	sta VIA_PCR				;4	;output bit 5 to the speaker

	lda VOICE_BIT			;4
	ror a					;2
	lda VOICE_BIT			;4
	ror a					;2
	sta VOICE_BIT			;4
	
	dec VOICE_CNT			;6
	bne @nobyte				;2/3
	
	lda #8					;2
	sta VOICE_CNT			;4
	lda <Z_SRC+1			;3
	beq @next				;2/3
	lda <Z_SRC+0			;3
	clc						;2
	adc #1					;2
	sta <Z_SRC+0			;3
	lda <Z_SRC+1			;3
	adc #0					;2
	sta <Z_SRC+1			;3
	jmp @next				;3
	
@mute:

	lda #0					;2
	sta VOICE_BIT			;3
	
@nobyte:

	.repeat 31/4			;waste 31 t-states
	lda >0
	.endrepeat
	lda <0

@next:

	.repeat 24
	lda >0
	.endrepeat
	
	dex						;2
	beq :+
	jmp @loop				;2/3
:

	lda <Z_SRC+0			;3
	sta VOICE_PTR+0			;4
	lda <Z_SRC+1			;3
	sta VOICE_PTR+1			;4

	rts
	
	
	
voice_data:

	.incbin "res/voice.bin"
	
voice_screen:

	.incbin "res/petface.bin"
	
voice_face:

	.byte $20,$20,$20,$20,$20,$20,$62,$62,$20,$20,$62,$62,$20,$20,$20,$20,$20,$20,$6c,$62,$7b,$6c,$62,$7b,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20
	.byte $e2,$e2,$20,$20,$e2,$e2,$20,$20,$20,$20,$20,$20,$62,$62,$20,$20,$62,$62,$20,$20,$20,$20,$20,$20,$e2,$e2,$20,$20,$e2,$e2,$e2,$e2,$20,$20,$e2,$e2,$e2,$e2,$20,$20,$e2,$e2,$62,$62,$20,$20,$62,$62,$6c,$62,$7b,$6c,$62,$7b,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20
	.byte $20,$a0,$20,$20,$a0,$20,$20,$a0,$20,$20,$a0,$20,$20,$62,$20,$20,$62,$20,$20,$62,$20,$20,$62,$20,$20,$a0,$20,$20,$a0,$20,$e1,$61,$20,$e1,$61,$20,$20,$e1,$61,$20,$e1,$61,$20,$62,$7b,$6c,$62,$20,$20,$6c,$7b,$6c,$7b,$20,$20,$7c,$7e,$7c,$7e,$20,$20,$20,$7c,$7e,$20,$20,$20,$20,$6c,$7b,$20,$20,$20,$20,$20,$20,$20,$20
	.byte $20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$e2,$20,$20,$e2,$20,$20,$e2,$20,$20,$e2,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$7c,$7e,$7c,$7e,$20,$20,$20,$61,$e1,$20,$20,$20,$20,$e1,$61,$20,$20,$20,$20,$e1,$61,$20,$20,$20,$20,$e1,$61,$20,$20
	.byte $20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$6c,$7b,$20,$20,$20,$20,$7c,$7e,$20,$20,$20,$20,$20,$20,$20,$20
	.byte $20,$20,$62,$62,$20,$20,$20,$20,$62,$62,$20,$20,$20,$62,$62,$62,$62,$20,$20,$62,$62,$62,$62,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$62,$62,$20,$20,$20,$20,$7c,$7e,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20
	.byte $20,$e2,$62,$62,$e2,$20,$20,$20,$61,$e1,$20,$20,$20,$fc,$62,$62,$fe,$20,$20,$20,$20,$20,$20,$20,$20,$20,$a0,$a0,$20,$20,$20,$20,$a0,$a0,$20,$20,$20,$20,$a0,$a0,$20,$20,$20,$20,$a0,$a0,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20
	.byte $20,$20,$20,$20,$20,$20,$20,$20,$e2,$e2,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20


voice_text:

	.byte $0f,$0e,$0c,$19,$20,$03,$0f,$0d,$0d,$0f,$04,$0f,$12,$05,$20,$10,$05,$14,$20,$0d,$01,$0b,$05,$13,$20,$09,$14,$20,$10,$01,$13,$13,$01,$02,$0c,$05
	.byte $10,$0f,$13,$13,$09,$02,$0c,$05	;possible

voice_face_anim:

	.byte VF_SOUND,VO_ZOOM_1
	.byte VF_SOUND,VO_ZOOM_2
	.byte VF_SOUND,VO_ZOOM_3
	.byte VF_SOUND,VO_ZOOM_4
	.byte VF_SOUND,VO_ZOOM_5
	.byte VF_MUTE
	.byte VO_IDLE,VO_IDLE,VO_IDLE,VO_IDLE
	.byte VO_BLINK
	.byte VO_IDLE,VO_IDLE,VO_IDLE,VO_IDLE
	.byte VO_LEFT,VO_LEFT,VO_LEFT,VO_LEFT
	.byte VO_IDLE,VO_IDLE,VO_IDLE,VO_IDLE
	.byte VO_BLINK
	.byte VO_IDLE,VO_IDLE,VO_IDLE,VO_IDLE
	.byte VO_RIGHT,VO_RIGHT,VO_RIGHT,VO_RIGHT
	.byte VO_IDLE,VO_IDLE,VO_IDLE,VO_IDLE
	.byte VF_PLAY
	.byte VF_CHAR,VO_OUWR					;o
	.byte VF_CHAR,VO_CDNSTXZ				;n
	.byte VF_CHAR,VF_CHAR,VO_CDNSTXZ		;ly
	.byte VO_AEI							;
	.byte VO_IDLE
	.byte VF_CHAR,VF_CHAR,VO_CDNSTXZ		;co
	.byte VO_OUWR							;
	.byte VF_CHAR,VO_BMP					;m
	.byte VF_CHAR,VF_CHAR,VO_BMP			;mo
	.byte VO_OUWR							;
	.byte VF_CHAR,VF_CHAR,VO_CDNSTXZ		;do
	.byte VO_OUWR							;
	.byte VF_CHAR,VF_CHAR,VO_OUWR			;re
	.byte VO_OUWR							;
	.byte VO_IDLE
	.byte VF_CHAR,VF_CHAR,VO_BMP			;pe
	.byte VO_AEI,VO_AEI						;
	.byte VF_CHAR,VO_CDNSTXZ				;t
	.byte VO_IDLE
	.byte VF_CHAR,VF_CHAR,VO_BMP			;ma
	.byte VO_AEI							;
	.byte VF_CHAR,VO_AEI					;k
	.byte VF_CHAR,VF_CHAR,VO_CDNSTXZ		;es
	.byte VO_CDNSTXZ						;
	.byte VO_IDLE
	.byte VF_CHAR,VF_CHAR,VO_AEI			;it
	.byte VO_CDNSTXZ						;
	.byte VO_IDLE
	.byte VF_CHAR,VF_CHAR,VO_BMP			;po
	.byte VO_AEI							;
	.byte VF_CHAR,VO_CDNSTXZ				;s
	.byte VF_CHAR,VF_CHAR,VO_CDNSTXZ		;si
	.byte VO_AEI							;
	.byte VF_CHAR,VO_BMP					;b
	.byte VF_CHAR,VF_CHAR,VO_CDNSTXZ		;le
	.byte VO_IDLE,VO_IDLE,VO_IDLE,VO_IDLE,VO_IDLE,VO_IDLE,VO_IDLE
	.byte VO_BLINK
	.byte VF_DELCHAR,VF_DELCHAR,VO_IDLE,VF_DELCHAR,VF_DELCHAR,VO_IDLE,VF_DELCHAR,VF_DELCHAR,VO_IDLE,VF_DELCHAR,VF_DELCHAR,VO_IDLE
	.byte VO_BLINK
	.byte VO_IDLE,VF_CHAR,VF_CHAR,VO_IDLE,VF_CHAR,VF_CHAR,VO_IDLE,VF_CHAR,VF_CHAR,VO_IDLE,VF_CHAR,VF_CHAR,VO_IDLE
	.byte VO_IDLE,VO_IDLE,VO_IDLE,VO_IDLE,VO_IDLE,VO_IDLE,VO_IDLE
	.byte VO_BLINK
	.byte VO_IDLE,VO_IDLE,VO_IDLE,VO_IDLE,VO_IDLE,VO_IDLE,VO_IDLE
	.byte VO_BLINK
	.byte VO_IDLE,VO_IDLE,VO_IDLE,VO_IDLE,VO_IDLE,VO_IDLE,VO_IDLE
	.byte VF_END
	
VOICE_PTR:		.word 0
VOICE_BIT:		.byte 0
VOICE_CNT:		.byte 0
VOICE_TEXT_PTR:	.byte 0
VOICE_SCR_PTR:	.byte 0
VOICE_FACE:		.byte 0
VOICE_PREVFACE:	.byte 0
VOICE_FACEANIM:	.byte 0
