SCENE_MEM_HIGH2=$7610
SCENE_MEM_HIGH1=$6c00
SCENE_MEM_NORMAL=$6450

	.include "base.s"
		
.segment "CODE"

main:
	.export main

	;turn on 'graphics' mode (removes gaps between character rows)
	
	;jsr e_scroll
	
	lda #<e_scroll_zx02
	ldx #>e_scroll_zx02
	jsr unpack_and_run_scene_high2
	
	lda #142
	jsr CHROUT
	lda #139
	sta RAND_SEED_1
	
	;initialize sound system
	
	lda #$0c		;keep graphics character set active
					;PET version of pest_init takes A contents to use in subsequent PCR writes
	

	jsr petplay_init
		
	; lda #$00				;to switch between the charsets $0C (standard) or $00 (lower case) can be used
	; jsr petplay_charset

	;jsr e_matrix
	;jsr e_timeline
	;jsr e_title
	;jsr e_floor
	;jsr e_maze
	;jsr e_checkers
	;jsr e_checkmate
	;jsr e_petflip
	;jsr e_waves
	;jsr e_greets
	;jsr e_morph
	;jsr e_bump
	;jsr e_voice
	;jsr e_noise

	lda #<music_part_0
	ldx #>music_part_0
	jsr unpack_and_play_music_part
	
	lda #<e_matrix_zx02
	ldx #>e_matrix_zx02
	jsr unpack_and_run_scene_high2
	
	jsr wait_marker
	
	lda #<e_timeline_zx02
	ldx #>e_timeline_zx02
	jsr unpack_and_run_scene_high2
	
	jsr wait_music_stop
	
	lda #<music_part_1
	ldx #>music_part_1
	jsr unpack_and_play_music_part
	
	lda #<e_title_zx02
	ldx #>e_title_zx02
	jsr unpack_and_run_scene_high1
	
	lda #<e_floor_zx02
	ldx #>e_floor_zx02
	jsr unpack_and_run_scene_high1
	
	lda #<music_part_2
	ldx #>music_part_2
	jsr unpack_and_play_music_part
	
	lda #<e_maze_zx02
	ldx #>e_maze_zx02
	jsr unpack_and_run_scene_high1
	
	jsr wait_music_stop
	
	lda #<music_part_3
	ldx #>music_part_3
	jsr unpack_and_play_music_part
	
	lda #<e_checkers_zx02
	ldx #>e_checkers_zx02
	jsr unpack_and_run_scene_high1
	
	lda #<e_checkmate_zx02
	ldx #>e_checkmate_zx02
	jsr unpack_and_run_scene_high1

	jsr wait_music_stop

	lda #<music_part_4
	ldx #>music_part_4
	jsr unpack_and_play_music_part
	
	lda #<e_petflip_zx02
	ldx #>e_petflip_zx02
	jsr unpack_and_run_scene
	
	lda #<e_waves_zx02
	ldx #>e_waves_zx02
	jsr unpack_and_run_scene
	
	jsr wait_music_stop
	
	lda #<music_part_5
	ldx #>music_part_5
	jsr unpack_and_play_music_part
	
	lda #<e_greets_zx02
	ldx #>e_greets_zx02
	jsr unpack_and_run_scene
	
	jsr wait_music_stop
	
	lda #<music_part_6
	ldx #>music_part_6
	jsr unpack_and_play_music_part
	
	lda #<e_morph_zx02
	ldx #>e_morph_zx02
	jsr unpack_and_run_scene

	jsr wait_music_stop
	
	lda #<music_part_7
	ldx #>music_part_7
	jsr unpack_and_play_music_part

	jsr wait_marker

	lda #<e_bump_zx02
	ldx #>e_bump_zx02
	jsr unpack_and_run_scene
	
	jsr wait_music_stop
	
	jsr petplay_done		;music ends here, rest of the scenes have their own sound code
	
	lda #<e_voice_zx02
	ldx #>e_voice_zx02
	jsr unpack_and_run_scene	
	
	lda #<e_noise_zx02
	ldx #>e_noise_zx02
	jsr unpack_and_run_scene	
	
	;as the memory gets corrupted after the full run, a re-run is not possible, thus the last scene loops indefinitely
:
	jmp :-
	
	
	
unpack_and_play_music_part:

	sta comp_data+0
	stx comp_data+1

	ldy #<music_data
	sty out_adr+0
	ldy #>music_data
	sty out_adr+1
	
	jsr petplay_stop
	
	jsr full_decomp
	
	lda #<music_data
	ldx #>music_data
	jmp petplay_start		;jsr:rts
	

	
unpack_and_run_scene:
	
	ldy #<SCENE_MEM_NORMAL
	sty out_adr+0
	ldy #>SCENE_MEM_NORMAL
	sty out_adr+1
	
	sta comp_data+0
	stx comp_data+1
	
	jsr full_decomp
	
	jmp SCENE_MEM_NORMAL
		
unpack_and_run_scene_high1:
	
	ldy #<SCENE_MEM_HIGH1
	sty out_adr+0
	ldy #>SCENE_MEM_HIGH1
	sty out_adr+1
	
	sta comp_data+0
	stx comp_data+1
	
	jsr full_decomp
	
	jmp SCENE_MEM_HIGH1
	
unpack_and_run_scene_high2:
	
	ldy #<SCENE_MEM_HIGH2
	sty out_adr+0
	ldy #>SCENE_MEM_HIGH2
	sty out_adr+1
	
	sta comp_data+0
	stx comp_data+1
	
	jsr full_decomp
	
	jmp SCENE_MEM_HIGH2
	

	
music_data:

	.export music_data
	.res 1470,0

	;.include "e_scroll.s"
	;.include "e_matrix.s"
	;.include "e_timeline.s"
	;.include "e_title.s"
	;.include "e_floor.s"
	;.include "e_maze.s"
	;.include "e_checkers.s"
	;.include "e_checkmate.s"
	;.include "e_petflip.s"
	;.include "e_waves.s"
	;.include "e_greets.s"
	;.include "e_morph.s"
	;.include "e_bump.s"
	;.include "e_voice.s"
	;.include "e_noise.s"
	


e_noise_zx02:
	.export e_noise_zx02
	.incbin "e_noise.zx02"
	
e_voice_zx02:
	.export e_voice_zx02
	.incbin "e_voice.zx02"
	
e_bump_zx02:
	.export e_bump_zx02
	.incbin "e_bump.zx02"

music_part_7:
	.export music_part_7
	.incbin "res\music_7.pm2.zx02"
	
e_morph_zx02:
	.export e_morph_zx02
	.incbin "e_morph.zx02"
	
music_part_6:
	.export music_part_6
	.incbin "res\music_6.pm2.zx02"
	
e_greets_zx02:
	.export e_greets_zx02
	.incbin "e_greets.zx02"

music_part_5:
	.export music_part_5
	.incbin "res\music_5.pm2.zx02"
	
e_waves_zx02:
	.export e_waves_zx02
	.incbin "e_waves.zx02"
		
e_petflip_zx02:
	.export e_petflip_zx02
	.incbin "e_petflip.zx02"
	
music_part_4:
	.export music_part_4
	.incbin "res\music_4.pm2.zx02"
	
e_checkmate_zx02:
	.export e_checkmate_zx02
	.incbin "e_checkmate.zx02"
	
e_checkers_zx02:
	.export e_checkers_zx02
	.incbin "e_checkers.zx02"
	
music_part_3:
	.export music_part_3
	.incbin "res\music_3.pm2.zx02"
	
e_maze_zx02:
	.export e_maze_zx02
	.incbin "e_maze.zx02"
			
music_part_2:
	.export music_part_2
	.incbin "res\music_2.pm2.zx02"
	
e_floor_zx02:
	.export e_floor_zx02
	.incbin "e_floor.zx02"
		
e_title_zx02:
	.export e_title_zx02
	.incbin "e_title.zx02"
		
music_part_1:
	.export music_part_1
	.incbin "res\music_1.pm2.zx02"
	
e_timeline_zx02:
	.export e_timeline_zx02
	.incbin "e_timeline.zx02"
	
e_matrix_zx02:
	.export e_matrix_zx02
	.incbin "e_matrix.zx02"
	
e_scroll_zx02:
	.export e_scroll_zx02
	.incbin "e_scroll.zx02"
	
music_part_0:
	.export music_part_0
	.incbin "res\music_0.pm2.zx02"
	
mem_top:
	.export mem_top